// wfpguiDlg.cpp : implementation file
//

#include "stdafx.h"
#include "wfpgui.h"
#include "wfpguiDlg.h"
#include <winnetwk.h>
#include <process.h>
#include <errno.h>
#include "jpersist.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWfpguiDlg dialog

CWfpguiDlg::CWfpguiDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWfpguiDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWfpguiDlg)
	m_exe = _T("");
	m_output = _T("");
	m_users = FALSE;
	m_shares = FALSE;
	m_services = FALSE;
	m_registry = FALSE;
	m_null = FALSE;
	m_nn = FALSE;
	m_groups = FALSE;
	m_all = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CWfpguiDlg::~CWfpguiDlg()
{
	//instantiate our persist object with the dir value we save from before
	CJPersist p(dir);
	//store the current data in m_exe so it will be there next time
	p.Store(m_exe);
}

void CWfpguiDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWfpguiDlg)
	DDX_Control(pDX, IDC_COMBO_COMPUTERS, m_net);
	DDX_Text(pDX, IDC_EDIT_WFPEXE, m_exe);
	DDX_Text(pDX, IDC_EDIT_OUTPUT, m_output);
	DDX_Check(pDX, IDC_CHECK_USERS, m_users);
	DDX_Check(pDX, IDC_CHECK_SHARES, m_shares);
	DDX_Check(pDX, IDC_CHECK_SERVICES, m_services);
	DDX_Check(pDX, IDC_CHECK_REG, m_registry);
	DDX_Check(pDX, IDC_CHECK_NULL, m_null);
	DDX_Check(pDX, IDC_CHECK_NN, m_nn);
	DDX_Check(pDX, IDC_CHECK_GROUPS, m_groups);
	DDX_Check(pDX, IDC_CHECK_ALL, m_all);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWfpguiDlg, CDialog)
	//{{AFX_MSG_MAP(CWfpguiDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_BROWSE, OnButtonBrowse)
	ON_BN_CLICKED(IDC_BUTTON_EXIT, OnButtonExit)
	ON_BN_CLICKED(IDC_BUTTON_SCAN, OnButtonScan)
	ON_BN_CLICKED(IDC_BUTTON_LAUNCH, OnButtonLaunch)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWfpguiDlg message handlers

BOOL CWfpguiDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	//Get our current directory and store it so we always access the same file
	//if you call GetCurrentDirectory with a buffer too small it will return
	//the size necessary for the buffer, so we call with a buffer which
	//is definitely too small to get the exact size we need. I prefer the
	//extra function call to wasted memory with an oversized buffer.
	DWORD size = GetCurrentDirectory(1,dir.GetBuffer(1));
	dir.ReleaseBuffer();
	GetCurrentDirectory(size,dir.GetBuffer(size));
	dir.ReleaseBuffer();
	dir += "\\exe.ini";

	//instantiate our persist object and load the data there if available
	CJPersist p(dir);
	m_exe = p.Load();
	
	init();
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CWfpguiDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWfpguiDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWfpguiDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CWfpguiDlg::init()
{
	//This may take some time on a big network so lets start the wait cursor
	CWaitCursor curs;
	if(!EnumerateNetRes(NULL)) MessageBox("Enumeration of Network Failed","ERROR");
	m_net.InsertString(0,"None");
	m_net.SetCurSel(0);
}


BOOL CWfpguiDlg::EnumerateNetRes(LPNETRESOURCE lpnr) 
{ 
    DWORD dwResult, dwResultEnum; 
    HANDLE hEnum; 
    DWORD cbBuffer = 16384;      // 16K is a good size 
    DWORD cEntries = 0xFFFFFFFF; // enumerate all possible entries 
    LPNETRESOURCE lpnrLocal = NULL;     // pointer to enumerated structures 
    DWORD i; 
 
    dwResult = WNetOpenEnum(RESOURCE_GLOBALNET, 
							RESOURCETYPE_ANY, 
							0,                 // enumerate all resources 
							lpnr,              // NULL first time this function is called 
							&hEnum);           // handle to resource 
 
    if (dwResult != NO_ERROR) 
	{ 
		return FALSE; 
    } 
 
	lpnrLocal = new NETRESOURCE[cbBuffer];

    do 
	{ 
		dwResultEnum = WNetEnumResource(hEnum,			// resource handle 
										&cEntries,      // defined locally as 0xFFFFFFFF 
										lpnrLocal,      // LPNETRESOURCE 
										&cbBuffer);     // buffer size 
 
        if (dwResultEnum == NO_ERROR) 
		{ 
            for(i = 0; i < cEntries; i++) 
            { 
                if(lpnrLocal[i].dwDisplayType == RESOURCEDISPLAYTYPE_SERVER)
				{
					m_net.AddString(lpnrLocal[i].lpRemoteName);
				}
                
				if( RESOURCEUSAGE_CONTAINER == (lpnrLocal[i].dwUsage & RESOURCEUSAGE_CONTAINER) &&
												lpnrLocal[i].dwDisplayType != RESOURCEDISPLAYTYPE_SERVER 
				  )
				{
                    if(!EnumerateNetRes(&lpnrLocal[i]))
					{
                        //possible error
					}
 
				}
			}
        } 
 
        else if (dwResultEnum != ERROR_NO_MORE_ITEMS) 
		{ 
			break; 
        } 
    } 
    while(dwResultEnum != ERROR_NO_MORE_ITEMS); 
 
    if(lpnrLocal != NULL) delete [] lpnrLocal;
 
    dwResult = WNetCloseEnum(hEnum); 
 
    if(dwResult != NO_ERROR) 
	{ 
        return FALSE; 
    } 
 
    return TRUE; 
}

void CWfpguiDlg::OnButtonBrowse() 
{
	UpdateData(TRUE);
	CFileDialog dlg(TRUE, NULL, NULL, OFN_EXPLORER, "Winfingerprint EXE (*.exe)|*.exe||" );
	if(dlg.DoModal() == IDOK)
	{
		m_exe = dlg.GetPathName();
		UpdateData(FALSE);
	}
}


void CWfpguiDlg::OnButtonExit() 
{
	EndDialog(0);
}

void CWfpguiDlg::OnButtonScan() 
{
	UpdateData(TRUE);
	
	if(m_exe.IsEmpty())
	{
		MessageBox("You Must Enter The Path of the Winingerprint Executable","Error");
		return;
	}

	//check to see if the output file has an htm or html extension, if not append one
	if(!m_output.IsEmpty())
	{
		int count = m_output.ReverseFind('.');
		if(count == -1) //no dot found
		{
			m_output += ".html"; //append .html
		}
		else //if there is a dot and the extension is not html or htm remove it and put html there
		{
			CString temp = m_output.Right(count);
			if(temp != ".html" && temp != ".htm")
			{
				temp = m_output.Left(count + 1);
				temp += "html";
				m_output = temp;
			}
		}
		UpdateData(FALSE);
	}

	//since BOOL's are int's converted to booleans we take their sum to find if none are selected.
	//if none are selected we default to all
	if((m_users + m_shares + m_services + m_registry + m_null + m_nn + m_groups + m_all) == 0) m_all = TRUE;

	//specific errors first
	//retrieve the name that is selected or typed in
	CString name;
	m_net.GetWindowText(name);
		
	if(m_nn == TRUE && name != "None")
	{
		MessageBox("You must chose either a network neighborhood scan OR a computer to scan.\r\n"
				   "Change Computer selection to None to scan the network neighborhood.","Error");
		return;
	}

	if(m_null == TRUE && (name == "None" && m_nn == FALSE))
	{
		MessageBox("You specified a Null Session scan and did not choose a mass scan or a Servername.\r\n"
				   "Please choose one and try again.","Error");
		return;
	}
	
	TCHAR	all[]		= " -a",
			shares[]	= " -d",
			groups[]	= " -g",
			nn[]		= " -m",
			null[]		= " -n",
			reg[]		= " -r",
			serv[]		= " -s",
			users[]		= " -u";


	const int size = 11;
	int offset = 0;
	int length;
	TCHAR* args[size];
	for(int x = 0; x < size; x++) args[x] = NULL;


	length = m_exe.GetLength()+1;
	TCHAR* exe = new TCHAR[length];
	strncpy(exe,(TCHAR*)m_exe.GetBuffer(length),length);
	m_exe.ReleaseBuffer();

	args[offset++] = exe;
	

	TCHAR* computer = NULL;
	if(name != "None")
	{
		name.Insert(0," -t ");
		length = name.GetLength()+1;
		computer = new TCHAR[length];
		strncpy(computer,(TCHAR*)name.GetBuffer(length),length);
		name.ReleaseBuffer();
		args[offset++] = computer;
	}

	if(!m_all)
	{
		if(m_users		== TRUE) args[offset++] = users;
		if(m_shares		== TRUE) args[offset++] = shares;
		if(m_services	== TRUE) args[offset++] = serv;
		if(m_groups		== TRUE) args[offset++] = groups;
		
	}
	else
	{
		args[offset++] = all;
	}

	if(m_registry	== TRUE) args[offset++] = reg;
	if(m_null		== TRUE) args[offset++] = null;
	if(m_nn			== TRUE) args[offset++] = nn;
	
	TCHAR* output = NULL;
	if(!m_output.IsEmpty())
	{
		m_output.Insert(0," -o ");
		length = m_output.GetLength()+1;
		output = new TCHAR[length];
		strncpy(output,(TCHAR*)m_output.GetBuffer(length),length);
		m_output.ReleaseBuffer();
		args[offset++] = output;
	}
	
	if(_spawnv(_P_WAIT,exe, args) != 0)
	{
		if(errno == ENOENT) MessageBox("Error Executing Winfingerprint\r\nFile Not Found","Error");
		else MessageBox("Error Executing Winfingerprint","Error");
	}

	delete [] exe;
	if(computer != NULL) delete [] computer;
	if(output	!= NULL) delete [] output;
	
}

void CWfpguiDlg::OnButtonLaunch() 
{
	UpdateData(TRUE);
	CString file;
		
	if(m_output.IsEmpty())
	{
		//if there is no string in output box the output file will be in the
		//directory of the executable and named winfingerprint.html
		file = m_exe.Left(m_exe.ReverseFind('\\') + 1);
		file += "winfingerprint.html";	
	}
	else 
	{
		//otherwise, use whatever is in the output box
		file = m_output;
	}

	ShellExecute(NULL, "open", file, NULL, NULL, SW_SHOWNORMAL);
}
